<?

////////////////////////////////////////////////////////////
//
// v-ine.php - a Web site referral service
//
////////////////////////////////////////////////////////////
//
// This script allows your visitors to send recommendations
// of your site to their friends.
//
// See readme.txt for more information.
//
// Author: Jon Thomas <http://jp.thomas.name>
// Last Modified: 6/10/02
//
// You may freely use, modify, and distribute this script.
//
////////////////////////////////////////////////////////////

//
// DEFINE THE VARIABLES
//

// subject of the referral e-mail
$subject = "Check out this great site!";

// the message sent if the user does not supply his own
$defaultMsg = "Hey FRIEND_NAME, check out this great site!\n\nYour friend, $userName";

// the URL of the submission form
$formURL = "";

// the URL of the "thanks" page
$thanksURL = "thanks.html";

// webmaster's e-mail for error reports and optional referral notices
$webmasterEmail = "";

// to receive referral notices, set to 1; otherwise, set to 0
$receiveNotices = 1;

//
// VALIDATE THE SUBMISSION
//

// validate the e-mail address
function is_email($string)
{
	$boolValue = ereg(
		// username includes alphanumeric characters, underscore, period, or hyphen
		'^[a-z0-9_\.-]+'.

		// address includes at-sign
		'@'.

		// domain name includes alphanumeric characters, hyphen, or period (in case of subdomains)
		'([a-z0-9-]+\.)+'.
		
		// domain includes 2-4 alphabetical characters
		'[a-z]{2,4}$',
		$string);

	return($boolValue);
}

// if the referring URL is not the form URL, print an error message and terminate the script
if ($HTTP_REFERER != $formURL) {
	die("Unauthorized use.");
}

// if the site URL is not set
if (!isset($url)) {
	// e-mail an alert to the webmaster
	mail($webmasterEmail, "v-ine Error", "v-ine was not properly configured at <$formURL>.  You must specify the site URL in the HTML form.  Customize the following code and insert it into the HTML form:\n\n<input type=\"hidden\" name=\"url\" value=\"http://yoursite.com\">");

	// print an error message and terminate the script
	die("<i>v-ine</i> is not properly configured.  We apologize for this inconvenience.  The webmaster has been alerted.");
}

// if friendName or friendEmail is not an array
if (!is_array($friendName) || !is_array($friendEmail)) {
	// e-mail an alert to the webmaster
	mail($webmasterEmail, "v-ine Error", "v-ine was not properly configured at <$formURL>.  You must add \"[]\" after the field names friendName and friendEmail like this:\n\n<input type=\"text\" size=\"20\" name=\"friendName[]\">");

	// print an error message and terminate the script
	die("<i>v-ine</i> is not properly configured.  We apologize for this inconvenience.  The webmaster has been alerted.");
}

// if the necessary user input is not provided, print an error message and terminate the script
if ($userName == "" || !is_email($userEmail)) {
	die("You must fill in your name and address.  Please go back and fill in the other information.");
}

// count the number of elements in the friend arrays using friendName
$noArrElements = count($friendName);

// remove empty elements from the friendName array
for ($i = 0; $i < $noArrElements; $i++) {
	if ($friendName[$i] == "") {
		unset($friendName[$i]);
	}
}

// remove empty elements from the friendEmail array
for ($i = 0; $i < $noArrElements; $i++) {
	if ($friendEmail[$i] == "") {
		unset($friendEmail[$i]);
	}
}

// count the number of elements in the friend arrays
$noFriendNames = count($friendName);
$noFriendEmails = count($friendEmail);

// if the number of elements is not equal, print an error message and terminate the script
if ($noFriendNames != $noFriendEmails) {
	die("You must fill in a name and address for each friend.  Please go back and fill in the other information.");
}

// cycle through the friendEmail array
for ($i = 0; $i < count($friendEmail); $i++) {
	// if an element is not a valid e-mail address, print an error message and terminate the script
	if (!is_email($friendEmail[$i])) {
		die("<b>$friendEmail[$i]</b> is an invalid e-mail address.  Please go back and correct this information.");
	}
}

//
// PROCESS THE SUBMISSION
//

// get the date and time
$datetime = date('l, F j \a\t g:i A T');

// if the user did not enter his own message, use the default
if ($message == "A default message will be sent if you do not enter your own message." || $message == "") {
	$message = $defaultMsg;
}

// e-mail a referral to each friend
for ($i = 0; $i < $noFriendEmails; $i++) {
	// replace FRIEND_NAME if found with name of friend
	$message = ereg_replace("FRIEND_NAME", $friendName[$i], $message);

	// e-mail the referral
	mail($friendEmail[$i], $subject, "$message\n\nURL: $url", "From: $userEmail");

	// replace the name of friend if found with FRIEND_NAME
	$message = ereg_replace($friendName[$i], "FRIEND_NAME", $message);
}

// if the webmaster wants to receive referral notices, e-mail him now
if ($receiveNotices) {
	for ($i = 0; $i < $noFriendNames; $i++) {
		$friendsList .= "$friendName[$i] <$friendEmail[$i]>\n";
	}

	mail($webmasterEmail, "v-ine Referral Notice", "$userName <$userEmail> referred\n\n$friendsList\nto $url on $datetime with the following message:\n\n$message");
}

// redirect to "thanks" page
header("Location: $thanksURL");

?>